import { ApiPropertyOptions } from '@nestjs/swagger';
import { AnyObject, Type } from './utils';
export declare const apiDecoratorsSymbol: unique symbol;
export declare const entityConstructorSymbol: unique symbol;
export interface ApiEntityRefType extends Type<unknown> {
    [apiDecoratorsSymbol]?: {
        swagger: (EntityConstructor: Type<unknown>) => void;
        validators: (EntityConstructor: Type<unknown>, realTarget: Type, groups: string[]) => void;
        forClassTransformations: (EntityConstructor: Type<unknown>) => void;
    }[];
    [entityConstructorSymbol]?: Type<unknown>;
}
export interface ApiPropertyRefOptions {
    entityPropertyKey?: string;
    overrideExisting?: boolean;
}
export declare class ApiPropertyRefDecorator {
    private swaggerOptions;
    private static readonly classValidatorStorage;
    private readonly classProto;
    private readonly propertyKey;
    private readonly normalizedEntityPropertyKey;
    private readonly options;
    private classValidatorStorage;
    constructor(classProto: AnyObject, propertyKey: string | symbol, swaggerOptions: ApiPropertyOptions, options: ApiPropertyRefOptions);
    addMetadata(): void;
    private copySwaggerDecorators;
    private copyClassValidatorDecorators;
    private copyClassTransformerDecorators;
}
export declare function ApiPropertyRef(swaggerOptions?: ApiPropertyOptions, options?: ApiPropertyRefOptions): PropertyDecorator;
