export interface Type<T = any> extends Function {
    new (...args: any[]): T;
}
export declare type AnyObject = Record<string | number | symbol, any>;
export declare type Required<T extends AnyObject, K extends keyof T = keyof T> = (Omit<T, K> & {
    [key in K]-?: T[key];
});
export declare function isClass(ctor: Type | unknown): ctor is Type<unknown>;
